Page MenuHomePhabricator

[OpenMP] Embed device files into the host IR
ClosedPublic

Authored by jhuber6 on Jan 3 2022, 9:59 AM.

Details

Summary

This patch adds support for embedding the device object files into the
host IR to create a fat binary. Each offloading file will be inserted
into a section with the following naming format
.llvm.offloading.<triple>.<arch>.<filename>.

Depends on D116542

Diff Detail

Event Timeline

jhuber6 created this revision.Jan 3 2022, 9:59 AM
jhuber6 requested review of this revision.Jan 3 2022, 9:59 AM
Herald added a project: Restricted Project. · View Herald TranscriptJan 3 2022, 9:59 AM
jhuber6 updated this revision to Diff 403413.Jan 26 2022, 2:46 PM

Updating after changing flag in D116542

jhuber6 updated this revision to Diff 404030.Jan 28 2022, 8:04 AM

Adding test for multiple input files to embed.

jhuber6 updated this revision to Diff 404033.Jan 28 2022, 8:15 AM

Add input filename to the section name to prevent it from being merged if the user does a link.

jhuber6 updated this revision to Diff 404038.Jan 28 2022, 8:23 AM

Remove test that was intended for previous commit.

Description and test have slightly diverged from implementation - filename is appended to disambiguate, but the filecheck regex only looks at the prefix and the name described in the commit message is missing the filename

JonChesterfield edited the summary of this revision. (Show Details)Jan 31 2022, 6:56 AM

Description and test have slightly diverged from implementation - filename is appended to disambiguate, but the filecheck regex only looks at the prefix and the name described in the commit message is missing the filename

Thanks, I changed it in the local commit but forgot to copy it over here.

JonChesterfield accepted this revision.Jan 31 2022, 6:59 AM
This revision is now accepted and ready to land.Jan 31 2022, 6:59 AM
This revision was landed with ongoing or failed builds.Jan 31 2022, 12:56 PM
This revision was automatically updated to reflect the committed changes.